// 2D
include <test_rounded_square.scad>;
include <test_line2d.scad>;
include <test_hull_polyline2d.scad>;
include <test_hexagons.scad>;

// 3D
include <test_rounded_cube.scad>;
include <test_rounded_cylinder.scad>;
include <test_crystal_ball.scad>;
include <test_line3d.scad>;
include <test_hull_polyline3d.scad>;
include <test_function_grapher.scad>;

// Transformation
include <test_bend.scad>;
include <test_along_with.scad>;

// Function
include <test_ptf_rotate.scad>;
include <test_cross_sections.scad>;
include <test_paths2sections.scad>;
include <test_in_polyline.scad>;
include <test_trim_shape.scad>;
include <test_midpt_smooth.scad>;

// Path
include <test_bezier_curve.scad>;
include <test_bezier_surface.scad>;
include <test_bezier_smooth.scad>;
include <test_helix.scad>;
include <test_golden_spiral.scad>;
include <test_archimedean_spiral.scad>;
include <test_sphere_spiral.scad>;
include <test_torus_knot.scad>;

// Extrude
include <test_ellipse_extrude.scad>;
include <test_stereographic_extrude.scad>;

// 2D Shape
include <test_shape_circle.scad>;
include <test_shape_arc.scad>;
include <test_shape_cyclicpolygon.scad>;
include <test_shape_ellipse.scad>;
include <test_shape_pie.scad>;
include <test_shape_square.scad>;
include <test_shape_trapezium.scad>;
include <test_shape_starburst.scad>;
include <test_shape_superformula.scad>;
include <test_shape_path_extend.scad>;

// 2D Shape Extrusion
include <test_ring_extrude.scad>;
include <test_helix_extrude.scad>;
include <test_golden_spiral_extrude.scad>;
include <test_archimedean_spiral_extrude.scad>;
include <test_sphere_spiral_extrude.scad>;
include <test_path_extrude.scad>;

// Utilities
include <util/test_sub_str.scad>;
include <util/test_split_str.scad>;
include <util/test_parse_number.scad>;
include <util/test_slice.scad>;
include <util/test_sort.scad>;
include <util/test_reverse.scad>;
include <util/test_fibseq.scad>;
include <util/test_bsearch.scad>;
include <util/test_choose.scad>;
include <util/test_dedup.scad>;
include <util/test_zip.scad>;
include <util/test_some.scad>;
include <util/test_every.scad>;
include <util/set/test_hashset.scad>;
include <util/map/test_hashmap.scad>;

// Voxel
include <voxel/test_vx_line.scad>;
include <voxel/test_vx_polyline.scad>;
include <voxel/test_vx_circle.scad>;
include <voxel/test_vx_cylinder.scad>;
include <voxel/test_vx_sphere.scad>;
include <voxel/test_vx_polygon.scad>;

